{ Sends a 10 character DEC of a HUB Address value, at a fixed interval }

PUB start(address)
    cognew (@entry,address)

DAT           org 0
entry         mov       DIRA,_bit30
              mov       cnt,#7                  '7 cycle overhead
              add       cnt,cnt                 'add current cnt
loop1         waitcnt   cnt,#200                'wait and then add 200 for below overhead
              rdlong    temp,PAR
              movs      decimal,#table     
              mov       charcnt,#11            '10 dec chars in a long + space
loop2         mov       uartTx,#48             'start at ASCII for "0"
decimal       cmpsub    temp,0-0 wc            'try 1 Billion first
        if_c  add       uartTx,#1
        if_c  jmp       #decimal      
              cmp       charcnt,#1 wz           'last charter one?
        if_z  mov       uartTX,#32              'replace with space
              or        uartTx,#$100            'set stopbit
              shl       uartTx,#1               'merge in startbit               
              mov       bitcnt,#10              '10bit uart
loop3         waitcnt   cnt,_baud
              shr       UartTx,#1 wc
              muxc      OUTA,_bit30
              djnz      bitcnt,#loop3
              add       decimal,#1              'try 100mill next        
              djnz      charcnt,#loop2
              add       cnt,_second             'restart main loop with 1sec delay
              jmp       #loop1
              
_second long 80_000_000                         '/2 or /4 if you want shorter delay
_baud   long 80_000_000/115200
_bit30  long |<30
table   long 1_000_000_000, 100_000_000, 10_000_000, 1_000_000, 100_000, 10_000, 1_000, 100, 10, 1,1 
temp    res 1
charcnt res 1
bitcnt  res 1
uartTx  res 1